<template>
<!--  style="height: fit-content"-->
  <div class="card flip-card" style="max-width: 100vh !important;margin: auto">
    <div class="flip-card-inner" id="flip-card-inner">

      <div v-if="startSceneShow && intro_poster.headline">
        <heading :data="defaultData" :flip="flip" :format="formatText" :heading="intro_headline_heading"/>
      </div>

      <div v-else-if="startSceneShow && intro_poster.starring_you">
        <starring-you :data="defaultData" :flip="flip"
                      :heading="intro_starring_you_heading" :title="intro_starring_you_title"/>
        </div>

      <div v-else-if="startSceneShow && intro_poster.hello_jerry" class="h-100">
        <hello-jerry :card3-bg-img="intro_hello_jerry_bg_img" :data="defaultData" :flip="flip"
          :heading="intro_hello_jerry_heading" :name="intro_hello_jerry_fName"/>
      </div>

      <div class="container flip-card-front" v-else-if="midSceneShow && !flipped">

        <div class="h-100" v-if="video_branching.two_videos">
          <two-videos :data="defaultData"
                      :image-click="imageClick"/>
        </div>

        <div class="h-100" v-if="video_branching.three_videos">
          <three-videos :data="defaultData"
                        :image-click="imageClick"/>
        </div>

        <div class="h-100" v-if="video_branching.four_videos">
          <four-videos :card3-mid-scene-h5="branching_four_midScene_h5" :data="defaultData" :image-click="imageClick"/>
        </div>

        <div class="h-100" v-if="video_branching.branching_two">
          <branching-two :data="defaultData"
            :image-click="imageClick"/>
        </div>

        <div class="h-100" v-if="video_branching.branching_three_hotspot">
          <branching-three-hotspot :data="defaultData"
            :image-click="imageClick"/>
        </div>

        <div class="h-100" v-if="video_branching.branching_three_share">
          <branching-three-share :data="defaultData"
            :image-click="imageClick"/>
        </div>

      </div>

<!--      replay button div -->
      <div v-if="endSceneShow && !videoPlaying" :style="`background-image:url(${getCtaBgImg})`"
           class="container flip-card-front">

        <div class="h-100" v-if="cta_card.retail">
          <retail :data="defaultData"
            :pause-audio="pauseAudio" :replay="replay"/>
        </div>

        <div class="h-100" v-if="cta_card.biz_card">
          <biz_card :data="defaultData" :has-cta-button="true"
            :pause-audio="pauseAudio" :replay="replay"/>
        </div>

        <div v-if="cta_card.yes" class="h-100">
          <yes :data="defaultData"
            :pause-audio="pauseAudio" :replay="replay"/>
        </div>

        <div v-if="cta_card.yesButton" class="h-100">
          <yes-button :data="defaultData" :pause-audio="pauseAudio" :replay="replay"/>
        </div>

        <div v-if="cta_card.yesForm" class="h-100">
          <yes-form :data="defaultData" :pause-audio="pauseAudio" :replay="replay"/>
        </div>

        <div v-if="cta_card.menuTwo" class="h-100">
          <menu-two :data="defaultData" :pause-audio="pauseAudio" :replay="replay"/>
        </div>

        <div v-if="cta_card.menuThree" class="h-100">
          <menu-three :data="defaultData" :pause-audio="pauseAudio" :replay="replay"/>
        </div>

        <div v-if="cta_card.viralSharing" class="h-100">
          <viral-sharing :data="defaultData" :pause-audio="pauseAudio" :replay="replay"/>
        </div>

        <div v-if="cta_card.emailModal" class="h-100">
          <email-modal :data="defaultData" :pause-audio="pauseAudio" :replay="replay"/>
        </div>

        <div v-if="cta_card.videoThreeHotspots" class="h-100">
          <video-three-hotspots :data="defaultData" :pause-audio="pauseAudio" :replay="replay"/>
        </div>

        <div v-if="cta_card.videoThreeSharing" class="h-100">
          <video-three-sharing :data="defaultData" :pause-audio="pauseAudio" :replay="replay"/>
        </div>

      </div>

      <div id="flip-card-back" class="flip-card-back">
        <video id="flip-card-second-video" ref="video" class="video-js vjs-16-9" height="100%" playsinline
               autoplay webkit-playsinline>
          <track :src="currentCaptionsSrc" ref="captions" kind="captions" srclang="en" label="English" >
        </video>

        <div>

          <video-overlays
            :current-hotspot="currentHotspot"
            :data="defaultData"
            :hotspot-show="hotspotShowTime"
            :intro_video="intro_video"
            :player="player"
            :show_overlay="fiveSecPosterShow"
            :video-change="currentVideoSrc.mp4"
            :show-slider="showSlider"
            :pause-video="pauseVideo"
            :resume-video="resumeVideo"
            :slider-pause-video="pauseVideoForSlider"
          />


        </div>

      </div>
    </div>
  </div>
</template>

<script>

module.exports = {
  props: ['defaultData', 'customizedStatesObject', 'formatText'],
  components: {
    'heading': httpVueLoader('components/intro-poster/heading.vue'),
    'starring-you': httpVueLoader('components/intro-poster/starring_you.vue'),
    'hello-jerry': httpVueLoader('components/intro-poster/hello_jerry.vue'),
    'two-videos': httpVueLoader('components/video_branching/two_videos.vue'),
    'three-videos': httpVueLoader('components/video_branching/three_videos.vue'),
    'four-videos': httpVueLoader('components/video_branching/four_videos.vue'),

    'branching-two': httpVueLoader('components/video_branching/branching_two.vue'),
    'branching-three-hotspot': httpVueLoader('components/video_branching/branching_three_hotspot.vue'),
    'branching-three-share': httpVueLoader('components/video_branching/branching_three_share.vue'),


    'retail': httpVueLoader('components/cta_card/retail.vue'),
    'biz_card': httpVueLoader('components/cta_card/biz_card.vue'),
    'email-modal': httpVueLoader('components/cta_card/email-modal.vue'),

    'yes-button': httpVueLoader('components/cta_card/yes-button.vue'),
    'yes-form': httpVueLoader('components/cta_card/yes-form.vue'),
    'menu-two': httpVueLoader('components/cta_card/menu-two.vue'),
    'menu-three': httpVueLoader('components/cta_card/menu-three.vue'),
    'viral-sharing': httpVueLoader('components/cta_card/viral-sharing.vue'),
    'video-three-hotspots': httpVueLoader('components/cta_card/video-three-hotspots.vue'),
    'video-three-sharing': httpVueLoader('components/cta_card/video-three-sharing.vue'),

    'yes': httpVueLoader('components/cta_card/yes.vue'),
    'video-overlays': httpVueLoader('components/intro-video/video_overlays.vue'),
    'video-player': httpVueLoader('components/player/video_player.vue')
  },
  computed: {

    getCtaBgImg() {
      return this.cta_card.retail ? this.$store.state.data['ctacard-retail-image']
        : (this.cta_card.biz_card ? this.$store.state.data['ctacard-bizcard-image']
          : ((this.cta_card.yesButton || this.cta_card.yes) ? this.$store.state.data['ctacard-yes-image']
            : (this.cta_card.yesForm ? this.$store.state.data['ctacard-yes-form-image']
              : (this.cta_card.menuTwo ? this.$store.state.data['ctacard-menu-two-image']
                : (this.cta_card.menuThree ? this.$store.state.data['ctacard-menu-three-image']
                  : (this.cta_card.viralSharing ? this.$store.state.data['ctacard-viral-share-image']
                    : (this.cta_card.emailModal ? this.$store.state.data['intro-poster-basicheadline-image'] : null)))))))
    },

    defaultVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['introVideo']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = { mp4: data['intro-video-mp4'], webm: data['intro-video-mp4'] }
      }
      // const decidedVideoSrc = decideVideoSrc(video, this.$mq, data['intro-video-mp4'], data['intro-video-webm'])
      // return decidedVideoSrc
      return videoSrc
    },

    video1Src() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching2Video1']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = { mp4: data['branching2-video1-mp4'], webm: data['branching2-video1-mp4'] }
      }

      return videoSrc
    },
    video2Src() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching2Video2']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = { mp4: data['branching2-video2-mp4'], webm: data['branching2-video2-mp4'] }
      }
      return videoSrc
    },

    branching_three_leftVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching3Video1']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = { mp4: data['branching3-video1-mp4'], webm: data['branching3-video1-mp4'] }
      }
      return videoSrc
    },
    branching_three_middleVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching3Video2']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = { mp4: data['branching3-video2-mp4'], webm: data['branching3-video2-mp4'] }
      }
      return videoSrc
    },
    branching_three_rightVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching3Video3']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = { mp4: data['branching3-video3-mp4'], webm: data['branching3-video3-mp4'] }
      }
      return videoSrc
    },

    branching_four_firstVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching4Video1']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = { mp4: data['branching4-video1-mp4'], webm: data['branching4-video1-mp4'] }
      }
      return videoSrc
    },
    branching_four_secondVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching4Video2']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = { mp4: data['branching4-video2-mp4'], webm: data['branching4-video2-mp4'] }
      }
      return videoSrc
    },
    branching_four_thirdVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching4Video3']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = { mp4: data['branching4-video3-mp4'], webm: data['branching4-video3-mp4'] }
      }
      return videoSrc
    },
    branching_four_fourthVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching4Video4']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = { mp4: data['branching4-video4-mp4'], webm: data['branching4-video4-mp4'] }
      }
      return videoSrc
    },

    branching_two_leftVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching2LeftVideo']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = {mp4: data['branching2-leftVideo-mp4'], webm: data['branching2-leftVideo-webm']}
      }
      return videoSrc
    },

    branching_three_hotspot_leftVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching3HotspotLeftVideo']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = {mp4: data['branching3-hotspot-leftVideo-mp4'], webm: data['branching3-hotspot-leftVideo-webm']}
      }
      return videoSrc
    },
    branching_three_hotspot_middleVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching3HotspotMiddleVideo']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = {mp4: data['branching3-hotspot-middleVideo-mp4'], webm: data['branching3-hotspot-middleVideo-webm']}
      }
      return videoSrc
    },

    branching_three_share_leftVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching3ShareLeftVideo']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = {mp4: data['branching3-share-leftVideo-mp4'], webm: data['branching3-share-leftVideo-webm']}
      }
      return videoSrc
    },
    branching_three_share_middleVideoSrc() {
      let videoSrc = {}
      const data = this.$store.state.data
      const video = data['branching3ShareMiddleVideo']
      if (video) {

        if (this.$mq === 'mobile') {
          videoSrc = {mp4: video['mobile_mp4_path'], webm: video['mobile_webm_path']}
        } else {
          videoSrc = {mp4: video['desktop_mp4_path'], webm: video['desktop_webm_path']}
        }

      } else {
        videoSrc = {mp4: data['branching3-share-middleVideo-mp4'], webm: data['branching3-share-middleVideo-webm']}
      }
      return videoSrc
    },

    showHotspotOne() {
      const hotspot = this.defaultData['clickable-hotspot-one']
      const val = typeof hotspot === 'string' ? (hotspot).toLowerCase() : hotspot
      let arr = ['yes', 'true', true, 'on']
      return arr.includes(val)
    },
    hotspotOneStartTime() {
      return this.mssToSeconds(this.defaultData['clickable-hotspot-starttime-one'])
    },
    hotspotOneEndTime() {
      return this.mssToSeconds(this.defaultData['clickable-hotspot-endtime-one'])
    },
    showHotspotTwo() {
      const hotspot = this.defaultData['clickable-hotspot-two']
      const val = typeof hotspot === 'string' ? (hotspot).toLowerCase() : hotspot
      let arr = ['yes', 'true', true, 'on']
      return arr.includes(val)
    },
    hotspotTwoStartTime() {
      return this.mssToSeconds(this.defaultData['clickable-hotspot-starttime-two'])
    },
    hotspotTwoEndTime() {
      return this.mssToSeconds(this.defaultData['clickable-hotspot-endtime-two'])
    },
    showHotspotThree() {
      const hotspot = this.defaultData['clickable-hotspot-three']
      const val = typeof hotspot === 'string' ? (hotspot).toLowerCase() : hotspot
      let arr = ['yes', 'true', true, 'on']
      return arr.includes(val)
    },
    hotspotThreeStartTime() {
      return this.mssToSeconds(this.defaultData['clickable-hotspot-starttime-three'])
    },
    hotspotThreeEndTime() {
      return this.mssToSeconds(this.defaultData['clickable-hotspot-endtime-three'])
    },

    showVideoCaptions() {
      const captions = this.defaultData['enable-video-captions']
      const val = typeof captions === 'string' ? (captions).toLowerCase() : captions
      let arr = ['yes', 'true', true, 'on']
      return arr.includes(val)
    }

  },
  data: function () {
    return {
      currentCaptionsSrc: this.defaultData['intro-video-captions'],

      showSlider: false,

      intro_headline_heading: this.defaultData['intro-poster-basicheadline-headline'],
      intro_starring_you_title: this.defaultData['intro-poster-starringhyou-subhead'],

      topFiveSecPosterText: this.defaultData['video-textoverlay-text'],

      flipped: false,
      startSceneShow: true,
      endSceneShow: false,
      fiveSecPosterShow: false,
      midSceneShow: false,
      videoPlaying: false,

      currentVideoSrc: {mp4: null, webm: null},

      cta_button_link: this.defaultData['footer-ctabutton-link'],

      soundEffect: new Audio(this.defaultData['cta-audio']),

      branching_two_halfClickable_img: this.defaultData['branching2-menu-image'],

      card2_heading: this.defaultData.card2_heading,
      intro_starring_you_heading: this.defaultData['intro-poster-starringyou-headline'],

      intro_video_mid_text_fName: this.defaultData.intro_video_mid_text_fName,
      intro_video_mid_text: this.defaultData.intro_video_mid_text,

      branching_three_oneThirdClickable_img: this.defaultData['branching3-menu-image'],


      intro_hello_jerry_bg_img: this.defaultData['intro-poster-hellojerry-image'],
      intro_hello_jerry_fName: this.defaultData['intro-poster-hellojerry-headline'],

      intro_hello_jerry_heading: this.defaultData['intro-poster-hellojerry-subhead'],
      branching_four_midScene_h5: this.defaultData['branching4-headline-text'],

      cta_yes_endSceneBtnText: this.defaultData['ctacard-yes-button-text'],

      intro_poster: {
        headline: this.customizedStatesObject.intro_poster === "Basic Headline",
        starring_you: this.customizedStatesObject.intro_poster === "Starring You",
        hello_jerry: this.customizedStatesObject.intro_poster === "Hello Jerry"
      },

      intro_video: {
        top_text: this.customizedStatesObject.intro_video === "top_text",
        mid_text: this.customizedStatesObject.intro_video === "middle_text",
        bottom_text: this.customizedStatesObject.intro_video === "bottom_text",
        animated_text: this.customizedStatesObject.intro_video === "animated_text",

        none: this.customizedStatesObject.intro_video === "no_text"
      },

      video_branching: {
        two_videos: this.customizedStatesObject.video_branching === "two_videos",
        three_videos: this.customizedStatesObject.video_branching === "three_videos",
        four_videos: this.customizedStatesObject.video_branching === "four_videos",

        branching_two: this.customizedStatesObject.video_branching === "branching 2 (1+hotspot)",
        branching_three_hotspot: this.customizedStatesObject.video_branching === "branching 3 (2+hotspot)",
        branching_three_share: this.customizedStatesObject.video_branching === "branching 3 (2+share)"
      },

      cta_card: {
        retail: this.customizedStatesObject.cta_card === "retail",
        biz_card: this.customizedStatesObject.cta_card === "biz_card",
        yes: this.customizedStatesObject.cta_card === "yes",

        yesButton: this.customizedStatesObject.cta_card === "yes button",
        yesForm: this.customizedStatesObject.cta_card === "yes form",
        menuTwo: this.customizedStatesObject.cta_card === "menu two",
        menuThree: this.customizedStatesObject.cta_card === "menu three",
        viralSharing: this.customizedStatesObject.cta_card === "menu three sharing",
        emailModal: this.customizedStatesObject.cta_card === "email modal",
        videoThreeHotspots: this.customizedStatesObject.cta_card === "video three hotspots",
        videoThreeSharing: this.customizedStatesObject.cta_card === "video three sharing"
      },

      skipBranchingPart: this.customizedStatesObject.video_branching === "linear",
      videoDuration: 0,

      player: null,
      videoOptions: {
        controls: true,
        poster: "images/flipcard-video-loader.gif",
        controlBar: {
          children: [
            "playToggle",
            "progressControl",
            "currentTimeDisplay",
            "timeDivider",
            "durationDisplay",
            "subsCapsButton",
            "volumePanel"
          ],
          volumePanel: {
            inline: false
          }
        },
        textTrackSettings: false
      },


      hotspotShowTime: false,
      currentHotspot: null,

      hotspotOne: {
        image: this.defaultData['clickable-hotspot-image-one'],
        url: this.defaultData['clickable-hotspot-url-one'],
        startTime: this.defaultData['clickable-hotspot-starttime-one'],
        endTime: this.defaultData['clickable-hotspot-endtime-one']
      },
      hotspotTwo: {
        image: this.defaultData['clickable-hotspot-image-two'],
        url: this.defaultData['clickable-hotspot-url-two'],
        startTime: this.defaultData['clickable-hotspot-starttime-two'],
        endTime: this.defaultData['clickable-hotspot-endtime-two']
      },
      hotspotThree: {
        image: this.defaultData['clickable-hotspot-image-three'],
        url: this.defaultData['clickable-hotspot-url-three'],
        startTime: this.defaultData['clickable-hotspot-starttime-three'],
        endTime: this.defaultData['clickable-hotspot-endtime-three']
      }

    }
  },
  watch:{
    'customizedStatesObject.intro_poster': {
      handler(){
        this.intro_poster = {
          headline: this.customizedStatesObject.intro_poster === "headline",
          starring_you: this.customizedStatesObject.intro_poster === "starring_you",
          hello_jerry: this.customizedStatesObject.intro_poster === "hello_jerry"
        }
      },
      deep: true
    },
    'customizedStatesObject.intro_video': {
      handler(){
        this.intro_video = {
          top_text: this.customizedStatesObject.intro_video === "top_text",
          mid_text: this.customizedStatesObject.intro_video === "middle_text",
          bottom_text: this.customizedStatesObject.intro_video === "bottom_text",
          none: this.customizedStatesObject.intro_video === "no_text"
        }
      },
      deep: true
    },
    'customizedStatesObject.video_branching': {
      handler(){
        this.video_branching = {
          two_videos: this.customizedStatesObject.video_branching === "two_videos",
          three_videos: this.customizedStatesObject.video_branching === "three_videos",
          four_videos: this.customizedStatesObject.video_branching === "four_videos",
          branching_two: this.customizedStatesObject.video_branching === "branching 2 (1+hotspot)",
          branching_three_hotspot: this.customizedStatesObject.video_branching === "branching 3 (2+hotspot)",
          branching_three_share: this.customizedStatesObject.video_branching === "branching 3 (2+share)"
        }
        this.skipBranchingPart = this.customizedStatesObject.video_branching === "linear"
      },
      deep: true
    },
    'customizedStatesObject.cta_card': {
      handler() {
        this.cta_card = {
          retail: this.customizedStatesObject.cta_card === "retail",
          biz_card: this.customizedStatesObject.cta_card === "biz_card",
          yes: this.customizedStatesObject.cta_card === "yes",

          yesButton: this.customizedStatesObject.cta_card === "yes button",
          yesForm: this.customizedStatesObject.cta_card === "yes form",
          menuTwo: this.customizedStatesObject.cta_card === "menu two",
          menuThree: this.customizedStatesObject.cta_card === "menu three"
        }
      },
      deep: true
    },
    'currentVideoSrc': {
      handler() {
        console.log('in currentVideoSrc watch ', this.currentVideoSrc)

        this.videoOptions.sources = []
        const mp4Src = {src: this.currentVideoSrc.mp4, type: 'video/mp4'}
        const webmSrc = {src: this.currentVideoSrc.webm, type: 'video/webm'};
        this.player.src(mp4Src, webmSrc)
        // this.player.load()
      },
      deep: true
    }
  },
  mounted() {

    if (!this.showVideoCaptions){
      this.videoOptions.controlBar.children = this.videoOptions.controlBar.children.filter(e => e !== 'subsCapsButton')
    }

    console.log('default video ', this.defaultVideoSrc)
    this.initPlayer()
  },
  methods: {

    createVideoTag() {
      const video = document.createElement('video')
      video.id = "flip-card-second-video"
      video.setAttribute('ref', 'video')
      video.setAttribute('class', 'video-js vjs-16-9')
      video.setAttribute('height', '100%')
      video.setAttribute('playsinline', true)
      video.setAttribute('autoplay', true)
      video.setAttribute('webkit-playsinline', true)

      const box = document.getElementById('flip-card-back');

      box.appendChild(video)

      // id="flip-card-second-video" ref="video" class="video-js vjs-16-9" height="100%" playsinline
      // autoplay webkit-playsinline
    },

    initPlayer() {
      const self = this
      this.player = window.videojs(this.$refs.video, this.videoOptions, () => {
        this.player.log('onPlayerReady', this);
      })

      this.player.on('ended', function () {
        self.flip()
      })

      this.player.on('timeupdate', function (e) {
        const data = {
          target: {
            currentTime: this.currentTime(),
            duration: this.duration()
          }
        }
        self.bringPoster(data)
      })
    },
    fastForward() {
      this.videoPlaying = false
      this.flip()
      this.$refs.video.currentTime = 0
      if (!this.video_branching.four_videos || this.endSceneShow) {
        this.soundEffect.play()
      }
    },

    playVideo() {
      this.videoPlaying = true
      this.$refs.video.load()
      this.$refs.video.play()
    },

    resumeVideo() {
      this.player.controlBar.removeClass('vjs-fade-out')

      this.showSlider = false
      this.videoPlaying = true
      this.$refs.video.play()
      this.player.play()
    },

    reSetState() {
      this.midSceneShow = false
      this.endSceneShow = false
      this.startSceneShow = false
      this.currentVideoSrc = this.defaultVideoSrc
      let self = this

      this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
      this.player.addRemoteTextTrack({
        kind: 'captions',
        src: this.defaultData['intro-video-captions'],
        srclang: 'English'
      }, true)

      setTimeout(function () {
        this.videoPlaying = true
        self.playVideo()
      }, 100)
    },
    pauseVideo() {
      this.videoPlaying = false
      let playPromise = this.$refs.video.play();
      let self = this
      if (playPromise !== undefined) {
        playPromise.then(_ => {
          self.$refs.video.pause();
        })
      }
    },
    pauseVideoForSlider() {
      this.player.controlBar.addClass('vjs-fade-out')

      // this.videoPlaying = false
      let playPromise = this.player.play();
      let self = this
      if (playPromise !== undefined) {
        playPromise.then(_ => {
          // self.$refs.video.pause();
          console.log('calling player pause method')
          self.player.pause()
        })
      }
    },

    pauseAudio() {
      this.soundEffect.pause()
      this.soundEffect.currentTime = 0
    },
    replay() {
      this.pauseAudio()
      this.pauseVideo()
      this.flipped = true
      $('#flip-card-inner').toggleClass('rot')
      let self = this
      setTimeout(function () {
        self.reSetState()
        !self.skipBranchingPart ? (self.midSceneShow = true) : (self.endSceneShow = true)
      }, 200)
    },
    flip() {
      console.log('in fli func')
      this.fiveSecPosterShow = false
      if (!this.flipped) {
        // video playing first time
        this.$store.commit('fireInterestedCall', 'Video play button click')
        this.flipped = true
        $('#flip-card-inner').toggleClass('rot')

        //video plays on first flip
        this.videoPlaying = true

        let self = this
        setTimeout(function () {
          self.reSetState()
          !self.skipBranchingPart ? (self.midSceneShow = true) : (self.endSceneShow = true)
        }, 150)
      } else {
        this.flipped = false
        this.player.pause()
        // this.pauseVideo()
        $('#flip-card-inner').toggleClass('rot')
      }
    },

    mssToSeconds(str) {
      let a = str.split(':'); // split it at the colons
      let ms = a[2] ? parseFloat('0.' + a[2]) : 0
      return (+a[0]) * 60 + (+a[1]) + ms
    },

    bringPoster(e) {
      this.videoDuration = e.target.duration

      if (this.currentVideoSrc.mp4 === this.defaultVideoSrc.mp4) {

        // let textTime = (this.mssToSeconds(this.defaultData['video-text-overlay-starttime'])).toString() || 3.0
        // textTime = (parseInt(textTime.split('.')[0]) * 60) + parseInt(textTime.split('.')[1])
        // console.log('textTime ', textTime)
        //
        //
        // let textEndTime = (this.mssToSeconds(this.defaultData['video-text-overlay-endtime'])).toString() || 5.0
        // textEndTime = (parseInt(textEndTime.split('.')[0]) * 60) + parseInt(textEndTime.split('.')[1])
        // console.log('textEndTime ', textEndTime)

        let textTime = this.mssToSeconds(this.defaultData['video-text-overlay-starttime']) || 3.0
        let textEndTime = this.mssToSeconds(this.defaultData['video-text-overlay-endtime']) || 5.0
        // console.log('textTime ', textTime, textEndTime)

        if (e?.target?.currentTime >= textTime && e?.target?.currentTime <= textEndTime) {
          this.fiveSecPosterShow = true
        }
        if (e?.target?.currentTime >= textEndTime && this.fiveSecPosterShow) {
          this.fiveSecPosterShow = false
        }

        // slider show
        // let sliderTime = (this.mssToSeconds(this.defaultData['slider-overlay-starttime'])).toString()
        // sliderTime = (parseInt(sliderTime.split('.')[0]) * 60) + parseInt(sliderTime.split('.')[1])
        //
        //
        // if (parseInt(e?.target?.currentTime) === sliderTime) {
        //   this.showSlider = true
        // }
        // if (e?.target?.currentTime >= e?.target?.duration && this.showSlider) {
        //   this.showSlider = false
        // }

        // for first hotspot
        if (this.showHotspotOne) {
          if (e.target.currentTime >= this.hotspotOneStartTime && e.target.currentTime <= this.hotspotOneEndTime) {
            this.currentHotspot = this.hotspotOne
            this.hotspotShowTime = true
          }
          if (e.target.currentTime >= this.hotspotOneEndTime && this.hotspotShowTime) {
            this.hotspotShowTime = false
          }
        }

        // for second hotspot
        if (this.showHotspotTwo) {
          if (e.target.currentTime >= this.hotspotTwoStartTime && e.target.currentTime <= this.hotspotTwoEndTime) {
            this.currentHotspot = this.hotspotTwo
            this.hotspotShowTime = true
          }
          if (e.target.currentTime >= this.hotspotTwoEndTime && this.hotspotShowTime) {
            this.hotspotShowTime = false
          }
        }

        // for third hotspot
        if (this.showHotspotThree) {
          if (e.target.currentTime >= this.hotspotThreeStartTime && e.target.currentTime <= this.hotspotThreeEndTime) {
            this.currentHotspot = this.hotspotThree
            this.hotspotShowTime = true
          }
          if (e.target.currentTime >= this.hotspotThreeEndTime && this.hotspotShowTime) {
            this.hotspotShowTime = false
          }
        }

      }

      if (e?.target?.currentTime >= e?.target?.duration) {
        this.videoPlaying = false
        // this.endSceneShow && this.soundEffect.play()
      }
    },

    branchingAnalytics(extra) {
      let data = {xKey: 'X87', extra: extra}
      this.$store.commit('fireAnalytics', data)
    },

    imageClick(side) {
      switch (side) {
        case "card1_left":
          this.currentVideoSrc = this.video1Src
          this.branchingAnalytics('Clicked Branch 1')

          this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
          this.player.addRemoteTextTrack({
            kind: 'captions',
            src: this.defaultData['branching2-video1-captions'],
            srclang: 'English'
          }, true)

          break;
        case "card1_right":
          this.currentVideoSrc = this.video2Src
          this.branchingAnalytics('Clicked Branch 2')

          this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
          this.player.addRemoteTextTrack({
            kind: 'captions',
            src: this.defaultData['branching2-video2-captions'],
            srclang: 'English'
          }, true)

          break;
        case "card2_left":
          this.currentVideoSrc = this.branching_three_leftVideoSrc
          this.branchingAnalytics('Clicked Branch 1')

          this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
          this.player.addRemoteTextTrack({
            kind: 'captions',
            src: this.defaultData['branching3-video1-captions'],
            srclang: 'English'
          }, true)

          break;
        case "card2_middle":
          this.currentVideoSrc = this.branching_three_middleVideoSrc
          this.branchingAnalytics('Clicked Branch 2')

          this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
          this.player.addRemoteTextTrack({
            kind: 'captions',
            src: this.defaultData['branching3-video2-captions'],
            srclang: 'English'
          }, true)

          break;
        case "card2_right":
          this.currentVideoSrc = this.branching_three_rightVideoSrc
          this.branchingAnalytics('Clicked Branch 3')

          this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
          this.player.addRemoteTextTrack({
            kind: 'captions',
            src: this.defaultData['branching3-video3-captions'],
            srclang: 'English'
          }, true)

          break;
        case "card3_first":
          this.currentVideoSrc = this.branching_four_firstVideoSrc
          this.branchingAnalytics('Clicked Branch 1')

          this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
          this.player.addRemoteTextTrack({
            kind: 'captions',
            src: this.defaultData['branching4-video1-captions'],
            srclang: 'English'
          }, true)

          break;
        case "card3_second":
          this.currentVideoSrc = this.branching_four_secondVideoSrc
          this.branchingAnalytics('Clicked Branch 2')

          this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
          this.player.addRemoteTextTrack({
            kind: 'captions',
            src: this.defaultData['branching4-video2-captions'],
            srclang: 'English'
          }, true)

          break;
        case "card3_third":
          this.currentVideoSrc = this.branching_four_thirdVideoSrc
          this.branchingAnalytics('Clicked Branch 3')

          this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
          this.player.addRemoteTextTrack({
            kind: 'captions',
            src: this.defaultData['branching4-video3-captions'],
            srclang: 'English'
          }, true)

          break;
        case "card3_fourth":
          this.currentVideoSrc = this.branching_four_fourthVideoSrc
          this.branchingAnalytics('Clicked Branch 4')

          this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
          this.player.addRemoteTextTrack({
            kind: 'captions',
            src: this.defaultData['branching4-video4-captions'],
            srclang: 'English'
          }, true)

          break;

        case "branching2_left":
          this.currentVideoSrc = this.branching_two_leftVideoSrc
          this.branchingAnalytics('Clicked Branching 2 Left Video')
          break;
        case "branching2_right":
          window.open(this.defaultData['branching2-rightHotspot-link'], "_blank")
          this.branchingAnalytics('Clicked Branching 2 hotspot')
          return
        case "branching3_hotspot_left":
          this.currentVideoSrc = this.branching_three_hotspot_leftVideoSrc
          this.branchingAnalytics('Clicked Branching 3 hotspot Left Video')
          break;
        case "branching3_hotspot_middle":
          this.currentVideoSrc = this.branching_three_hotspot_middleVideoSrc
          this.branchingAnalytics('Clicked Branching 3 hotspot Left Video')
          break;
        case "branching3_hotspot_right":
          window.open(this.defaultData['branching3-rightHotspot-link'], "_blank")
          this.branchingAnalytics('Clicked Branching 3 hotspot click')
          return

        case "branching3_share_left":
          this.currentVideoSrc = this.branching_three_share_leftVideoSrc
          this.branchingAnalytics('Clicked Branching 3 Share Left Video')
          break;
        case "branching3_share_middle":
          this.currentVideoSrc = this.branching_three_share_middleVideoSrc
          this.branchingAnalytics('Clicked Branching 3 Share Left Video')
          break;
        case "branching3_share_right":
          $('#myModal').modal('show')
          this.branchingAnalytics('Clicked Branching 3 hotspot click')
          return

        default:
          this.currentVideoSrc = this.defaultVideoSrc

          this.player.removeRemoteTextTrack(this.player.remoteTextTracks()[0])
          this.player.addRemoteTextTrack({
            kind: 'captions',
            src: this.defaultData['intro-video-captions'],
            srclang: 'English'
          }, true)

          break;

      }
      this.pauseAudio()
      this.flipped = true
      $('#flip-card-inner').toggleClass('rot')
      let self = this
      setTimeout(function () {
        self.midSceneShow = false
        self.endSceneShow = true
        self.videoPlaying = true

        setTimeout(async () => {
          self.playVideo()
        }, 100)

      }, 150)
    }
  },
  beforeDestroy() {
    this.pauseAudio()
    if (this.player) {
      this.player.dispose();
    }
  }
}
</script>

